/* Copyright (c) 1997, MpegTV LLC */
#ifndef _misc_h
#define _misc_h
#ifndef lint
static const char rcsid_misc_h[] = "$Header: /net/hopkins/var/home/tristan/mpeg/include/RCS/misc.h,v 1.40 1998/06/04 11:10:07 tristan Exp $";
#endif

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */

/*--------------------------------------------------------------------------+
| General configuration flags												|
+--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------+
| Architecture specific configuration flags									|
+--------------------------------------------------------------------------*/
/* "config.h" must be included at the very beginning of misc.h */
#include "config.h"

/*--------------------------------------------------------------------------+
| General includes															|
+--------------------------------------------------------------------------*/
#ifdef _REENTRANT
#include <pthread.h>
#endif

/* for non-POSIX source, some include files must be included before any POSIX includes */

/* undef the flag _POSIX_SOURCE */
#ifdef _POSIX_SOURCE
#	undef _POSIX_SOURCE
#endif

#if defined(BSDI)
#	include <sys/time.h>
#endif

#if 0
#ifdef INCLUDE_FOR_STRUCT_TIMEVAL
	/* struct timeval is defined in INCLUDE_FOR_STRUCT_TIMEVAL */
/*#	include INCLUDE_FOR_STRUCT_TIMEVAL*/
#	include <sys/time.h>

#endif /* INCLUDE_FOR_STRUCT_TIMEVAL */
#endif /* 0 */

#if 0 /* Tristan Savatier - Mon Aug 5 00:31:20 PDT 1996 */
//#ifdef CONFIG_linux
//#	include <linux/time.h>
//#else /* not CONFIG_linux */
//#	include <sys/time.h>
//#endif /* not CONFIG_linux */
#endif /* 0 - Tristan Savatier - Mon Aug 5 00:31:20 PDT 1996 */

#ifndef CONFIG_next
#ifdef HAVE_SYS_TYPES_H
/* u_int etc... are defined in <sys/types.h> */
#	include <sys/types.h>
#endif /* HAVE_SYS_TYPES_H */
#endif /* not CONFIG_next */

#if 0
///* restore the flag _POSIX_SOURCE */
//#if defined(MPEG_POSIX_SOURCE) && !defined(_POSIX_SOURCE)
//#	define _POSIX_SOURCE
//#endif
#endif /* 0 */

/* restore the flag _POSIX_SOURCE */
#if defined(MPEG_POSIX_SOURCE) && !defined(_POSIX_SOURCE)
#	define _POSIX_SOURCE
#endif

#ifdef SOLARIS
#	define __EXTENSIONS__	/* needed to define ioctl's TCSETS with solaris */
#endif

#ifdef LINUX
#ifndef _BSD_SOURCE
#	define _BSD_SOURCE /* we need this to have access to rindex(), gethostid() etc */
#endif
#ifndef _SVID_SOURCE
#	define _SVID_SOURCE /* we need this to have access to usleep() in unistd.h */
#endif
#endif

#ifdef SGI
#	define _BSD_TYPES
#endif

#ifdef CONFIG_next
#ifdef HAVE_SYS_TYPES_H
/* u_int etc... are defined in <sys/types.h> */
#	include <sys/types.h>
#endif /* HAVE_SYS_TYPES_H */
#endif /* CONFIG_next */


/* #include <assert.h> 	we include our own improved "mpeg_assert.h", later */
#include <ctype.h>
#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
/* #include <float.h> 	not used */
/* #include <grp.h> 	not used */
#include <limits.h>
/* #include <locale.h> 	not used */
#include <math.h>
/* #include <pwd.h> 	not used */
#include <setjmp.h>

#if 0 /* Tristan Savatier - Fri Jan 17 18:59:24 PST 1997 */
///* workaround <setjmp.h> bug in Solaris 2.5... */
//#ifdef SOLARIS
//	typedef int jmp_buf_fixed[20];
//#	define jmp_buf jmp_buf_fixed
//#endif
#endif /* 0 - Tristan Savatier - Fri Jan 17 18:59:24 PST 1997 */

#ifdef SGI
	/*
	 * There is a bug in one of SGI's header files under Irix 6.2 causing
	 * _POSIX93 to be not set to 1, in turn causing SIGKILL to not be
	 * defined properly by <signal.h>.  This is a workaround for this bug.
	 */
#	define _POSIX93 1
#endif
#include <signal.h>

/* #include <stdarg.h> 	not used */
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef HAVE_STRINGS_H
#include <strings.h>	/* for rindex */
#endif

#include <time.h>
#ifdef HAVE_UNISTD_H
#	include <unistd.h>
#endif /* HAVE_UNISTD_H */
#include <utime.h>

/* non POSIX.1 sys/ includes: */

/* struct timeval is defined in <sys/time.h> */
#include <sys/time.h>

#include <sys/stat.h>
#include <sys/times.h>
#include <sys/types.h>

#include <sys/utsname.h>
#include <sys/wait.h>
#include <sys/termios.h>

#if 0 /* Tristan Savatier - Tue Dec 17 15:22:25 PST 1996 */
//#include <sys/stdtypes.h>
//#include <sys/file.h>
#endif /* 0 - Tristan Savatier - Tue Dec 17 15:22:25 PST 1996 */

#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <sys/ioctl.h>

/* not POSIX.1 includes: */
#ifdef NEED_MEMORY_H
#	include <memory.h>
#endif /* NEED_MEMORY_H */


#if 0
#if defined(CONFIG_sun4) || defined(CONFIG_sun4gcc) || defined(CONFIG_sun5gcc)
#	include <floatingpoint.h>
#endif
#endif /* 0 */

#ifndef _POSIX_SOURCE

#if 0
	/*
	 * This trick is to includes <sys/param.h>, which is not part of the POSIX.1 Interface.
	 * <sys/param.h> defines MAXHOSTNAMLENTH and gethostname().
	 * This trick works on the Sun. I hope it works also on other machines...
	 */

	/* define __sys_signal_h to avoid including <sys/signal.h> */ 
#	define __sys_signal_h

#	include <sys/param.h>
#endif /* 0 */

#endif /* not _POSIX_SOURCE */

/*
 * The following standard types must be defined after system includes and before
 * local includes.
 */
#ifdef INT16
#	define	_INT16	INT16
	typedef INT16			int16;		/* signed type that holds exactly 16 bits */
#	define	_UINT16	unsigned INT16
	typedef _UINT16	u_int16;	/* unsigned type that holds exactly 16 bits */
	typedef _UINT16	uint16;
#endif /* INT16 */
#ifdef INT32
#	define	_INT32	INT32
	typedef INT32			int32;		/* signed type that holds exactly 32 bits */
#	define	_UINT32	unsigned INT32
	typedef _UINT32	u_int32;	/* unsigned type that holds exactly 32 bits */
	typedef _UINT32	uint32;
#endif /* INT32 */
#ifdef INT64
	typedef INT64			int64;	/* signed type that holds exactly 64 bits */
	typedef unsigned INT64	u_int64;/* unsigned type that holds exactly 64 bits */
#endif /* INT64 */


/* "values.h" must be included after PC_DEBUG has been defined */
#ifdef NO_VALUES

#	include "mpeg_values.h"

#else /* not NO_VALUES */

#	ifdef CONFIG_mips
		/*
		 * We have to work around a mips bug: including <values.h> is
		 * ineffective if BITSPERBYTE is defined, and this macro is
		 * indeed defined (by some indirect inclusion of <sys/map.h>).
		 */
#		undef	BITSPERBYTE
		/*
		 * We have to work around another mips bug:
		 * #include <values.h> does not seem to work, causing the
		 * file "values.h" (located in the directory $MPEG_DIR/include)
		 * to be included.
		 */
#		include </usr/include/values.h>

#	else /* CONFIG_mips */
	
#		include <values.h>
	
#	endif /* CONFIG_mips */

#endif /* NO_VALUES */

#if 0 /* Tristan Savatier - Thu Oct 30 21:30:41 PST 1997 */
//#include "c_var.h"
#endif /* 0 - Tristan Savatier - Thu Oct 30 21:30:41 PST 1997 */
#include "mpeg_assert.h"
#include "portable.h"
#ifdef USE_DMALLOC
#include "dmalloc.h"
#endif /* USE_DMALLOC */

/*--------------------------------------------------------------------------+
| Macros:																	|
+--------------------------------------------------------------------------*/
/*
 * Number of bits in a type (assuming 8 bits in a byte).
 * Generally defined in <values.h>, but sometimes missing.
 */
#ifndef BITS
#define BITS(type) (8 * sizeof(type))
#endif

/*
 * anint() returns the nearest  integral  value  to  x,  except
 * halfway  cases  are  rounded to the integral value larger in
 * magnitude.  This corresponds to the Fortran generic  intrin-
 * sic function anint().
 *
 * double anint(x)
 * double x;
 */

/* according to ANSI C, the following should work the same (faster) */
#define	ANINT(d)	((d)>=0?(int)((d)+0.5):(int)((d)-0.5))

/*
 * nint() converts x into int format rounding  to  the  nearest
 * int value, except halfway cases are rounded to the int value
 * larger in magnitude.  This corresponds to the  Fortran  gen-
 * eric intrinsic function nint().
 *
 * int nint(x)
 * double x;
 */

/* this should be the same but faster: */
#define	NINT(d)		((int)ANINT(d))

/*
 * Division of integers with rounding (this is //).  Half values are rounded
 * away from zero.
 * Note: d > 0, and no side effect permitted in the parameters.
 */
/* #define DIV_ROUNDED(n, d) ((n)>=0 ? ((n)+((d)>>1))/(d) : ((n)-((d)>>1))/(d)) */
/*
 * The following definition should generate a faster code when d is a
 * constant equal to a power of two.
 */
#define DIV_ROUNDED(n, d) ((n)>=0 ? (int)((u_int)((n)+(((u_int)(d))>>1))/(u_int)(d)) : -(int)((u_int)(-(n)+(((u_int)(d))>>1))/(u_int)(d)))

/*
 * fast_div_rounded() is equivalent to div_rounded(),
 * but uses FAST_INT_DIV() rather than "/".
 * It is not recommended when d is a constant known to
 * be a power of 2.
 */
#define FAST_DIV_ROUNDED(n, d) ((n)>=0 ? FAST_INT_DIV((u_int)((n)+((d)>>1)),(d)) : FAST_INT_DIV(((n)-((d)>>1)),(d)))

/* division of unsigned integers with rounding. Note: d > 0 */
#define UDIV_ROUNDED(n, d) ((((u_int)(n))+(((u_int)(d))>>1))/(u_int)(d))

/* 
 * Extend sign.
 * n is a signed integer value expressed on b bits where b < 8 * sizeof(int).
 * Higher bits (above b) are supposed to be cleared.
 * If bit b is set, the higher bits will be set to 1 to extend the sign.
 */
#define EXTEND_SIGN(n, b) 	((n) & (1 << ((b)-1)) ? (n) | ~((1 << (b)) - 1) : (n))



/* exact (double) value of 1 << n, works for all n up to DSIGNIF-1 (DSIGNIF=53) */
#define POWER_OF_2(n)	((double)(1L<<((n)/2))*(double)(1L<<((n)-(n)/2)))

#ifdef NO_TEMPNAM
#	define	tempnam(dir, pfx)	tmpnam(NULL)
#endif

/* added for BSD compatibility */

#undef bzero
#define bzero(b,len) memset(b,0,(size_t)len)

#undef creat
#define	creat(name, mode)	open(name, O_WRONLY|O_CREAT|O_TRUNC|O_BINARY, mode)

#ifdef NO_RANDOM
	extern long lrand48(void);
#	define	random()	((long)lrand48())
#endif

/* number of items in an array */
#define sizeofarray(t) (sizeof(t)/sizeof(t[0]))

/*  minimum & maximum */
#define Max(a,b)	((a)<(b)?(b):(a))
#define Min(a,b)	((a)>(b)?(b):(a))

/* absolute value */
#define Abs(a)		((a)<0?-(a):(a))

/* Boolean negation. b should be Bool */
#define not(b)		((Bool)!((int)(b)))

/* higher byte of short */
#define hi_byte(v)	((char)((v)>>BITS(char)))

/* lower byte of short */
#define lo_byte(v)	((char)(v))

/* normalize x in [a, b] (clamp) */
#define NORMALIZE(x, a, b)	 ((x)<(a)?(a):(x)>(b)?(b):(x))

/* faster special case for normalize int x in [0, 255] */
#define NORMALIZE_0_255(x)	 ((((u_int)(x))>>8)?((x)<0?0:255):(x))


/* faster special case for normalize int x in [-256, 255] */
#define NORMALIZE_M256_255(x)	NORMALIZE(x, -256, 255)


/* exit status */
#ifndef EXIT_SUCCESS
#	define EXIT_SUCCESS	0
#endif

#ifndef EXIT_FAILURE
#	define EXIT_FAILURE	1
#endif

/* True if integer is odd */
#define	is_odd(n)	((n)&1)

/* True if integer is even */
#define	is_even(n)	(!is_odd(n))


/*
 * Fast integer divide.  If DOUBLE_DIVIDE_FASTER is defined, FAST_INT_DIV
 * takes advantage of floating-point co-processor.
 * This macro should not be used when y is a constant equal to a power
 * of 2 (e.g. 128).  In this case, "/" is always faster.
 */
#ifdef DOUBLE_DIVIDE_FASTER
#	define	FAST_INT_DIV(x, y) ((int)((double)(x)/(double)(y)))
#else
#	define	FAST_INT_DIV(x, y) ((x)/(y))
#endif

/*
 * MINVAL(type) and MAXVAL(type) are the minimum and maximum values that can be
 * handeled by a signed integer data types.
 *
 * MAXSHORT, MAXINT and MAXLONG are defined by <values.h>, and the following
 * assertions should be verified:
 *
 * MAXSHORT == MAXVAL(short)
 * MAXINT == MAXVAL(int)
 * MAXLONG == MAXVAL(long)
 */

#ifdef CONFIG_mips
/*
 * We have to work around a nasty bug of the mips compiler:
 * (char)((char)1 << 7) is wrongly evaluated as 128 (instead of -128)
 * by the compiler.
 * It seems that a cast to unsigned before the outmost cast is a workaround:
 * (char)((unsigned char)1 << 7) is evaluated as -128.
 */
#	define MINVAL(type)	((type)((unsigned type)1 << (BITS(type) - 1)))
#else /* not CONFIG_mips */
#	define MINVAL(type)	((type)((type)1 << (BITS(type) - 1)))
#endif /* not CONFIG_mips */

#define MAXVAL(type)	((type)~(MINVAL(type)))

/* some <values.h> do not define MININT */
#ifndef MININT
#	define MININT	MINVAL(int)
#endif

/* max size of path names */
#ifndef PATH_MAX
#	ifdef _POSIX_PATH_MAX
#		define PATH_MAX _POSIX_PATH_MAX
#	else
		/* dirty trick: the directive #error is refused by the old cc ! */
		"fatal error: PATH_MAX must be defined in config.h"
#	endif
#endif

/* NOTE: macro argument `x' IS stringified, and this is what I want! */
#ifdef __STDCPP__
#define stringify(x)		#x
#else
#define stringify(x)		"x"
#endif


/*--------------------------------------------------------------------------+
| Data types																|
+--------------------------------------------------------------------------*/
/* standard types */

/* s_char should be used when char *MUST* be signed */
#ifdef __STDC__
	typedef	signed char	s_char;
#else /* not __STDC__ */
	typedef	char	s_char;	/* if not ANSI-C we must hope that "char" is signed */
#endif /* not __STDC__ */

#ifndef HAVE_SYS_TYPES_H

	typedef	unsigned long	u_long;
	typedef unsigned short	u_short;
	typedef unsigned int	u_int;
	typedef unsigned char	u_char;

#endif /* not HAVE_SYS_TYPES_H */

#ifndef T_TYPES_DEFINED
#if 0
	typedef char *caddr_t;
#endif /* 0 */
	typedef	long	off_t;
	typedef u_int	size_t;
#endif /* T_TYPES_DEFINED */

#if 0 /* Tristan Savatier - Sat Oct 19 00:04:11 PDT 1996 */
///* Boolean */
//typedef enum bool {False, True} Bool;
#endif /* 0 - Tristan Savatier - Sat Oct 19 00:04:11 PDT 1996 */

/*
 * Big problem with the "enum typedef enum bool {False, True} Bool" !
 * It appears that in <X11/Xlib.h>, Bool True and False are defined
 * as follows:
 * #define Bool int
 * #define True 1
 * #define False 0
 * This is very unfortunate (enum is better). Our enum definition would
 * not be compatible...
 */
 
#ifndef Bool
#define Bool int
#endif

#ifndef True
#define True 1
#endif

#ifndef False
#define False 0
#endif

/*
 * Do not define Bool as a typedef enum if you plan to set
 * the value of Bool from dbxtoll (bug in dbxtool in 4.0.3).
 * Use the following instead:
 *
 * 	typedef u_char Bool;
 * #	define False	0
 * #	define True	1
 */


/*--------------------------------------------------------------------------+
| External declarations:													|
+--------------------------------------------------------------------------*/
/* external declarations forgotten in standard include files */
extern int fsync(int);


#if defined(CONFIG_sun4) || defined(CONFIG_sun4gcc)
extern time_t time(time_t *);
extern int printf(const char *, DOTDOTDOT) );
extern int fprintf(FILE *, const char *, DOTDOTDOT) );
extern int scanf(const char *, DOTDOTDOT) );
extern int fscanf(FILE *, const char *, DOTDOTDOT) );
extern int sscanf(const char *, const char *, DOTDOTDOT) );
extern int perror(const char *) ); /* type should be void */
extern int fputc(char, FILE *);
extern int fgetc(FILE *);
extern int fclose(FILE *);
extern int fseek(FILE *, off_t, int);
extern int puts(const char *);
extern int fputs(const char *, FILE *);
extern int fflush(FILE *);
extern int rewind(FILE *);
extern size_t fwrite(const char *, size_t, size_t, FILE *);
extern size_t fread(char *, size_t, size_t, FILE *);
extern int _filbuf(FILE *);
extern int _flsbuf(u_char, FILE *);
extern int rename(const char *, const char *);
extern int ioctl(int, int, caddr_t);
extern int gettimeofday(struct timeval *, struct timezone *);
extern int system(const char *);
extern int usleep(u_int);
extern int toupper(char); /* type should be char */
extern int tolower(char); /* type should be char */
extern double strtod(const char *, char **);
extern double atof(const char *);
extern long strtol(const char *, char **, int);

#ifndef _POSIX_SOURCE
/* The following routine are NOT part of the POSIX.1 interface: */

#ifndef ftruncate
extern int ftruncate(int, off_t);
#endif /* not ftruncate */

#ifndef truncate
extern int truncate(const char *, off_t);
#endif /* not truncate */

extern int strftime(char *, int, const char *, struct tm *);
extern int srandom(int);

extern char * initstate(unsigned int, char *, int);
extern char * setstate(char *);

#ifndef random
extern long random(void);
#endif /* not random */

#ifndef gethostname
extern int gethostname(char *, int);
#endif /* not gethostname */

#endif /* not _POSIX_SOURCE */
#endif /* defined(CONFIG_sun4) || defined(CONFIG_sun4gcc) */

#ifdef CONFIG_sun5gcc
#ifndef fileno
	extern int	fileno(FILE *);
#endif /* not fileno */

#endif /* CONFIG_sun5gcc */

#ifdef CONFIG_next

/* extern int ftruncate(int, off_t); */

#endif /* CONFIG_next */

#ifdef HAVE_DRAND48

extern double drand48(void);
extern double erand48(unsigned short xsubi[3]);
extern long lrand48(void);
extern long nrand48(unsigned short xsubi[3]);
extern long mrand48(void);
extern long jrand48(unsigned short xsubi[3]);
extern void srand48(long seedval);
extern unsigned short *seed48(unsigned short seed16v[3]);
extern void lcong48(unsigned short param[7]);

#endif /* HAVE_DRAND48 */


#endif /* _misc_h */
